#!/bin/bash

# Copyright (C) 2016  Stefan Vargyas
# 
# This file is part of Trie-Gen.
# 
# Trie-Gen is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Trie-Gen is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Trie-Gen.  If not, see <http://www.gnu.org/licenses/>.

#
# File generated by a command like:
# $ gen-test -T print-stats-alphabets
#

[[ "$1" =~ ^-u[0-9]+$ ]] &&
u="${1:2}" ||
u=""

diff -u$u -L print-stats-alphabets.old <(echo \
'$ print() { printf '\''%s\n'\'' "$@"; }
$ printc() { awk '\''{ printf("%c\n", strtonum("0x" $1)) }'\'' <<< "$1"; }
$ trie0() { set -o pipefail && ../src/trie "$@" 2>&1|sed -r '\''s|^#|\\\0|'\''; }
$ stats() { sed -nr '\''s/^#/\\\0/p'\''; }
$ ../src/trie --stats --trie=array < alphabets.txt|stats
\# node size:  2080
\# node count: 312
\# nodes size: 648960
$ ../src/trie --stats --trie=ternary < alphabets.txt|stats
\# node size:  48
\# node count: 517
\# nodes size: 24816'
) -L print-stats-alphabets.new <(
echo '$ print() { printf '\''%s\n'\'' "$@"; }'
print() { printf '%s\n' "$@"; } 2>&1 ||
echo 'command failed: print() { printf '\''%s\n'\'' "$@"; }'

echo '$ printc() { awk '\''{ printf("%c\n", strtonum("0x" $1)) }'\'' <<< "$1"; }'
printc() { awk '{ printf("%c\n", strtonum("0x" $1)) }' <<< "$1"; } 2>&1 ||
echo 'command failed: printc() { awk '\''{ printf("%c\n", strtonum("0x" $1)) }'\'' <<< "$1"; }'

echo '$ trie0() { set -o pipefail && ../src/trie "$@" 2>&1|sed -r '\''s|^#|\\\0|'\''; }'
trie0() { set -o pipefail && ../src/trie "$@" 2>&1|sed -r 's|^#|\\\0|'; } 2>&1 ||
echo 'command failed: trie0() { set -o pipefail && ../src/trie "$@" 2>&1|sed -r '\''s|^#|\\\0|'\''; }'

echo '$ stats() { sed -nr '\''s/^#/\\\0/p'\''; }'
stats() { sed -nr 's/^#/\\\0/p'; } 2>&1 ||
echo 'command failed: stats() { sed -nr '\''s/^#/\\\0/p'\''; }'

echo '$ ../src/trie --stats --trie=array < alphabets.txt|stats'
../src/trie --stats --trie=array < alphabets.txt|stats 2>&1 ||
echo 'command failed: ../src/trie --stats --trie=array < alphabets.txt|stats'

echo '$ ../src/trie --stats --trie=ternary < alphabets.txt|stats'
../src/trie --stats --trie=ternary < alphabets.txt|stats 2>&1 ||
echo 'command failed: ../src/trie --stats --trie=ternary < alphabets.txt|stats'
)

